from ipaddress import IPv4Network, IPv6Network

from orchestrator.domain.base import ProductBlockModel
from orchestrator.types import SubscriptionLifecycle


class IASGatewayBlockInactive(
    ProductBlockModel, lifecycle=[SubscriptionLifecycle.INITIAL], product_block_name="IASGatewayBlock"
):
    lt_ipv4_network: IPv4Network | None = None
    lt_ipv6_network: IPv6Network | None = None


class IASGatewayBlockProvisioning(IASGatewayBlockInactive, lifecycle=[SubscriptionLifecycle.PROVISIONING]):
    lt_ipv4_network: IPv4Network | None = None
    lt_ipv6_network: IPv6Network | None = None


class IASGatewayBlock(IASGatewayBlockProvisioning, lifecycle=[SubscriptionLifecycle.ACTIVE]):
    lt_ipv4_network: IPv4Network
    lt_ipv6_network: IPv6Network
